import express from "express";
const formParser = require("body-parser").urlencoded({ extended: false });
import { PortierClient } from "portier";

const portier = new PortierClient({
  //broker: "https://broker.flylocal.io",
  redirectUri: ((process.env.NODE_ENV !== 'production') ? "http://localhost:3010" : "https://iflylocal.com") + "/login/verify",
});

const app = express();
app.use(express.json())
app.use(express.urlencoded({ extended: false }))

app.get("/", (req, res) => {
  res.type("html").end(`
    <p>Enter your email address:</p>
    <form method="post" action="/login/auth">
      <input name="email" type="email">
      <button type="submit">Login</button>
    </form>
  `);
});

app.post("/auth", formParser, (req, res) => {
  portier.authenticate(req.body.email).then((authUrl) => {
    res.redirect(303, authUrl);
  });
});

app.post("/verify", formParser, (req, res) => {
  portier.verify(req.body.id_token).then((email) => {
    res.type("html").end(`
      <p>Verified email address ${email}!</p>
    `);
  });
});

// app.get('/test', function (req, res) {
//   res.send('Test successful')
// })

export default {
  path: '/login',
  handler: app
}